 '>Bambino-17a
'>Robot R-Bambino
Sertxd("B17a",cr)		'report program number

#PicAxe 20M2
#no_data

            	

'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt. 
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA

'Bambino-01	'Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02	'Test InfraRed input
'Bambino-02a	'Test Eye light values
'Bambino-02b	'Test Whisker light values and put in EEPROM
'Bambino-03	'Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-04	'Set servos to mid position	
'Bambino-05	'Calibrate servo mid positions and put in EEPROM.
'Bambino-06	'Introduce _iStand:- initialise with feet in mid position
'Bambino-07	'Set rollR
'Bambino-08	'Set rollL
'Bambino-09	'Check rollR, rollL
'Bambino-10	'Introduction of _Stand
'Bambino-11	'Investigate effect of rollspeed;	watch roll for all three speeds
'Bambino-12	'Investigate effect of rollspeed;	watch Roll and Stand for all three speeds
'Bambino-13	'Check paceFL paceFR;	Investigate effect of pacespeed
'Bambino-14	'Check Fd
'Bambino-15	'Test _Rt, _Lt
'Bambino-16	'Test _Bk
'Bambino-17	'Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
            	'Introduction of ACT parameter 'Ado'
'Bambino-17a 'Demo routine            	

'modified
'--------
'start:

'New
'---
'Beep150

symbol servopace    =c.0    'left connector
symbol servoroll    =c.4    'right connector
symbol VoiceLed     =c.5
symbol eyeLedL_     =c.2    'low =>LED on 
symbol eyeLedR_     =b.1    'low =>LED on
symbol whiskerLedL_ =c.3    'low =>whisker LED on
symbol whiskerLedR_ =b.3    'low =>whisker LED on
symbol eyeR         =c.7		  	
symbol eyeL         =c.1		  	
symbol iIRin        =c.6
symbol oIRout       =b.2


symbol spulse	=b2
symbol iA 		=b3
symbol rollat 	=b4
symbol paceat 	=b5

symbol rollC	=155	'100 is roll to the left
symbol rollR      =173'176
symbol rollL      =135'130
symbol rollspeed  =b6   '4 is too fast, 0 won't move
symbol paceC	=145	'100 is left foot back
symbol paceFR	=130'125'120'105	'Right foot forward
symbol paceFL	=160'165'170'185	'Left  foot forward
symbol paceFRmax	=100	'Right foot forward
symbol paceFLmax	=190	'Left  foot forward
symbol sframe     =20'35'time between servo pulses
symbol pacespeed  =b7   '6 is about max for servos to keep up
symbol Ado		=b8	'parameter for ACTs

'symbol rollCoffset	=rollC -150
'symbol paceCoffset	=paceC -150


'IRin cmnds PicAxe controller
'these are actual tested values 
'"AXE040=I-R UPGRADE .pdf" is wrong for 20M2
'-------------------------------------------
'Mute(20)      Power(21)
'1(0)    2(1)      3(2)
'4(3)    5(4)      6(5)
'7(6)    8(7)      9(8)
'P+(16)  0(9)     V+(18)
'P-(17) 10(12)    V-(19)

symbol IRkeyMute  =20
symbol IRkeyPower =21
symbol IRkey1     =0
symbol IRkey2     =1
symbol IRkey3     =2
symbol IRkey4     =3
symbol IRkey5     =4
symbol IRkey6     =5
symbol IRkey7     =6
symbol IRkey8     =7
symbol IRkey9     =8
symbol IRkey0     =9
symbol IRkey10p   =12	'10+ 10plus
symbol IRkeyPp    =16	'P-  Pplus
symbol IRkeyPm    =17	'P+  Pminus
symbol IRkeyVp    =18	'V-  Vminus
symbol IRkeyVm    =19	'V+  Vminus


'All startX run automatically on PowerOn
'suspend 1	
initialise:
	high eyeLedR_	'make output
	high eyeLedL_	'make output
	gosub _iStand
	rollspeed =1  	'4 is too fast, 0 won't move
	pacespeed =2   	'6 is about max for servos to keep up  

'resume 1

start:	
	gosub beep150
'#rem
	Ado =4
	gosub RockAdo
	gosub Stand
	Ado =8
	gosub FdAdo
	Ado =8
	gosub BkAdo

'	goto start
'#endrem	 
	gosub ToggleEyes  'alter eyeR so we know program is running
	gosub B_fast
	gosub Fd
	gosub Fd
	gosub Fd
	gosub Fd
	gosub EyeRon
	gosub B_turn
	gosub Rt
	gosub Rt
	gosub Rt
	gosub Rt
	gosub EyesON
	gosub B_fast
	gosub Fd
	gosub Fd
	gosub Fd
	gosub Fd
	gosub EyeLon
	gosub B_turn
	gosub Lt
	gosub Lt
	gosub Lt
	gosub Lt

	gosub EyesON
	Ado =12
	gosub BkAdo

	goto start


'-----------------------------------------
'Acts
'----
RockAdo:
	for iA=1 to Ado  
 	  gosub _rollR
	  gosub _rollL
	 next iA 
	return
	
FdAdo:
	for iA=1 to Ado  
	  gosub Fd
	 next iA 
	return

BkAdo:
	for iA=1 to Ado 
	  gosub Bk
	 next iA 
	return

ToggleEyes:
	toggle eyeLedR_	'alter eyeR so we know program is running
	toggle eyeLedL_	'alter eyeR so we know program is running
	return

EyesON:
	low eyeLedR_
	low eyeLedL_
	return
EyeRON:
	high eyeLedR_
	low eyeLedL_
	return
EyeLON:
	low eyeLedR_
	high eyeLedL_
	return

'-----------------------------------------
'Behaviours
'----------
B_fast:
	rollspeed =3
	pacespeed =4 
	return
B_medium:
	rollspeed =2
	pacespeed =3 
	return
B_slow:
	rollspeed =1
	pacespeed =2 
	return
B_turn:	
	rollspeed =1	'slow so foot doesn't bounce
	pacespeed =5 
	return

'-----------------------------------------
'Actions
'-------
beep150:
	sound VoiceLed,(150,10)
	return

Fd:
sertxd (" Fd")
	if paceat<paceC then _FdL 'else _FdL
_FdR:
'sertxd ("_FdR")
	gosub _rollL
	gosub _RF
	gosub Stand
	return
_FdL:
'sertxd ("_FdL")
	gosub _rollR
	gosub _LF
	gosub Stand
	return
	

Bk:
sertxd (" Bk")
	if paceat<paceC then _BkR 'else _BkL
_BkL:
	gosub _rollR
	gosub _RF
	gosub Stand
	return
_BkR:
	gosub _rollL
	gosub _LF
	gosub Stand
	return


Rt:
	if paceat<paceC then gosub Fd	'need left foot forward
	gosub _RF
	return
	
Lt:
	if paceat>paceC then gosub Fd	'need right foot forward
	gosub _LF
	return

_RF:
'sertxd ("_RF")
	for spulse=paceat to paceFR step -pacespeed
	  paceat =spulse
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pulsout servopace,paceat	'pulse servo
	  pause sframe
	 next spulse
	return 
_LF:
'sertxd ("_LF")
	for spulse=paceat to paceFL step pacespeed
	  paceat =spulse
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pulsout servopace,paceat	'pulse servo
	  pause sframe
	 next spulse
	return 

Stand:	'stand with both feet flat
sertxd (" Sd")
	if rollat<rollC then _StandR 'else _StandL
_StandL:
'sertxd ("_SL")
	for spulse=rollat to rollC step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_StandR:
'sertxd ("_SR")
	for spulse=rollat to rollC step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 


_rollL:
'sertxd ("_rL")
	for spulse=rollat to rollL step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
	 
_rollR:
'sertxd ("_rR")
	for spulse=rollat to rollR step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

_iStand:
'initialise with feet in mid position
	for spulse=0 to 10
	  pulsout servopace,paceC	'pulse servo paceC
	  pulsout servoroll,rollC	'pulse servo rollC
	  pause 70				'pause 70ms - do it slowly
	 next spulse
	rollat =rollC
	paceat =paceC 
	return 
'-----------------------------------------
'start1:
togeyes:
	gosub ToggleEyes  'alter eyeR so we know program is running
	pause 500
	goto togeyes
'-----------------------------------------

