'>Bambino-18b
'>Robot R-Bambino
Sertxd("B18b",cr)		'report program number

#PicAxe 20M2
#no_data

'Bambino-01	'Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02	'Test InfraRed input
'Bambino-02a	'Test Eye light values
'Bambino-02b	'Test Whisker light values and put in EEPROM
'Bambino-03	'Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-04	'Set servos to mid position	
'Bambino-05	'Calibrate servo mid positions.and put in EEPROM
'Bambino-06	'Introduce _iStand:- initialise with feet in mid position
'Bambino-07	'Set rollR
'Bambino-08	'Set rollL
'Bambino-09	'Check rollR, rollL
'Bambino-10	'Introduction of _Stand
'Bambino-11	'Investigate effect of rollspeed;	watch roll for all three speeds
'Bambino-12	'Investigate effect of rollspeed;	watch Roll and Stand for all three speeds
'Bambino-13	'Check paceFL paceFR;	Investigate effect of pacespeed
'Bambino-14	'Check Fd
'Bambino-15	'Test Rt, Lt
'Bambino-15a	'Test T2L Turn to Light, T2D Turn to Dark
'Bambino-16	'Test Bk
'Bambino-17	'Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
            	'Introduction of ACT parameter 'Ado'
'Bambino-17a 'Demo routine            	
'Bambino-18	'Walk Fd with obstacle avoidance using eyes from 02a
'Bambino-18a	'Walk Fd with drop-off avoidance using whiskers values from 02b
'Bambino-18b	'rewritten with autocalibration of down whiskers and reading of whiskers as subroutines


            	
'Walk Fd with drop-off avoidance
'-------------------------------
            	
'modified
'--------
'calibrateholewhiskers:
'QGwhiskerL:		Query whisker Left, scaling now done in calibrateholewhiskers:
'QGwhiskerR:		Query whisker Right, scaling now done in calibrateholewhiskers:
'temp now temp0

'New
'---
'tempw
'tempHi_wLg		'whisker Left ground reading
'tempLo_wRg		'whisker Left ground reading

symbol servopace    =c.0	'left connector
symbol servoroll    =c.4	'right connector
symbol VoiceLed_    =c.5      'low =>LED on 
symbol eyeLedL_     =c.2      'low =>LED on 
symbol eyeLedR_     =b.1      'low =>LED on
symbol whiskerLedL_ =c.3      'low =>whisker LED on
symbol whiskerLedR_ =b.3      'low =>whisker LED on
symbol eyeR         =c.7	'adc	  	
symbol eyeL         =c.1	'adc	  	
symbol whiskerL     =b.6      'adc whisker Down Left		  	
symbol whiskerR     =b.0      'adc whisker Down Right		  	
symbol iIRin        =c.6
symbol oIRout       =b.2

symbol general 	=b0
symbol temp0	=b0
symbol B_flags    =b3
symbol defaultB   =bit31	'defaultBehaviour 1=use default
'symbol           =b4
symbol spulse 	=b5
symbol iA 		=b6
symbol  i 		=b6	'calibrateholewhiskers:	
symbol rollat 	=b7
symbol paceat 	=b8

symbol rollC	=150	'100 is roll to the left
symbol rollR      =rollC+15 
symbol rollL      =rollC-15
symbol rollspeed  =b9   '4 is too fast, 0 won't move
	rollspeed =1  	'4 is too fast, 0 won't move
symbol paceC	=150	'100 is left foot back
symbol paceFR	=paceC-20	'Right foot forward
symbol paceFL	=paceC+20	'Left  foot forward
symbol paceFRmax	=100	'Right foot forward
symbol paceFLmax	=190	'Left  foot forward
symbol sframe     =20	'time between servo pulses
symbol pacespeed  =b10   '6 is about max for servos to keep up
	pacespeed =2   	'6 is about max for servos to keep up  
symbol Ado		=b11	'parameter for ACTs
symbol obstacle   =b12  '%11 bitmap of obstacles  %LeftRight
symbol lightL     =b13  'light level Left
symbol lightR     =b14  'light level Right
symbol tempw       =w8
symbol  tempLo_wRg  =b16
symbol  tempHi_wLg  =b17


'depending on the sensors holedetectL and holedetectR may need to be different
symbol holedetectL=50	'scaled light level difference for holes
symbol holedetectR=50	'scaled light level difference for holes
'edit holedetect values so Bambino can see table edges

symbol EEholedetectR =252
symbol EEholedetectL =253
write EEholedetectR,holedetectR
write EEholedetectL,holedetectL

initialise:
	low eyeLedR_	'make output LED on
	low eyeLedL_	'make output LED on
	gosub _iStand
	defaultB =1		'defaultBehaviour On

	gosub calibrateholewhiskers

	
start:


	obstacle =0
	gosub EyesOFF

	gosub QwhiskerL	'and update obstacle map
	gosub QwhiskerR	'and update obstacle map

Walk:	
	gosub B_fast
	b0 =obstacle 			'to use bits
	if bit0=0 then
	  low eyeLedR_
	 endif 
	if bit1=0 then
	  low eyeLedL_
	 endif 
	on obstacle gosub Fd,Lt,Rt,Bk 
	goto start                    'loop back to start


'-----------------------------------------
'Acts
'----

RockAdo:
	for iA=1 to Ado  
 	  gosub _rollR
	  gosub _rollL
	 next iA 
	return
	
FdAdo:
	for iA=1 to Ado 
	  gosub Fd
	 next iA 
	return
	
BkAdo:
	for iA=1 to Ado 
	  gosub Bk
	 next iA 
	return
	

'-----------------------------------------
'Behaviours
'----------
B_fast:
	rollspeed =3
	pacespeed =6 
	return
	
B_turn:	
	rollspeed =1	'slow so foot doesn't bounce
	pacespeed =5 
	return	
'-----------------------------------------
'Actions
'-------

beep150:
	sound VoiceLed_,(150,10)
	return

EyesOFF:
	high eyeLedR_
	high eyeLedL_
	return
	
EyesON:
	low eyeLedR_
	low eyeLedL_
	return
		

Fd:
  sertxd (" Fd")
	if defaultB=1 then gosub B_fast
	if paceat<paceC then _FdL 'else _FdL
_FdR:
'sertxd ("_FdR")
	gosub _rollL
	gosub _RF
	gosub Stand
	return
_FdL:
'sertxd ("_FdL")
	gosub _rollR
	gosub _LF
	gosub Stand
	return
	

Bk:
  sertxd (" Bk")
	if defaultB=1 then gosub B_fast
	if paceat<paceC then _BkR 'else _BkL
_BkL:
	gosub _rollR
	gosub _RF
	gosub Stand
	return
_BkR:
	gosub _rollL
	gosub _LF
	gosub Stand
	return


Rt:
	if paceat<paceC then gosub Fd	'need left foot forward
	if defaultB=1 then gosub beep150
	if defaultB=1 then gosub B_turn
	gosub _RF
	return
	
Lt:
	if paceat>paceC then gosub Fd	'need right foot forward
	if defaultB=1 then gosub beep150
	if defaultB=1 then gosub B_turn
	gosub _LF
	return

_RF:
'sertxd ("_RF")
	for spulse=paceat to paceFR step -pacespeed
	  paceat =spulse
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pulsout servopace,paceat	'pulse servo
	  pause sframe
	 next spulse
	return 
_LF:
'sertxd ("_LF")
	for spulse=paceat to paceFL step pacespeed
	  paceat =spulse
	  pulsout servoroll,rollat	'pulse servo hold in position
	  pulsout servopace,paceat	'pulse servo
	  pause sframe
	 next spulse
	return 
	

Stand:	'stand with both feet flat
'  sertxd (" Sd")
	if rollat<rollC then _StandR 'else _StandL
_StandL:
'sertxd ("_SL")
	for spulse=rollat to rollC step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
_StandR:
'sertxd ("_SR")
	for spulse=rollat to rollC step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 


_rollL:
'sertxd ("_rL")
	for spulse=rollat to rollL step -rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 
	 
_rollR:
'sertxd ("_rR")
	for Spulse=rollat to rollR step rollspeed
	  rollat =spulse
	  pulsout servoroll,rollat	'pulse servo
	  pulsout servopace,paceat	'pulse servo hold in position
	  pause sframe
	 next spulse
	return 

_iStand:
'initialise with feet in mid position
	for spulse=0 to 10
	  pulsout servopace,paceC	'pulse servo paceC
	  pulsout servoroll,rollC	'pulse servo rollC
	  pause 70				'pause 70ms - do it slowly
	 next spulse
	rollat =rollC
	paceat =paceC 
	return 
'-----------------------------------------
'Sense
'-----
calibrateholewhiskers:
'take averages of 8 readings per whisker
	w8 =0	'clear tempHi,tempLo
	low whiskerLedL_				'eyeL on
	for i=0 to 7
'		low whiskerLedL_			'eyeL on
		readadc whiskerL,temp0
'		high whiskerLedL_			'eyeL off		
		sertxd("L",#temp0)
		temp0 =temp0 /8
		tempHi_wLg =tempHi_wLg +temp0
		sertxd(" ",#tempHi_wLg,cr)
	  next i	
	high whiskerLedL_				'eyeL off
	low whiskerLedR_				'eyeL on
	for i=0 to 7
'		low whiskerLedR_			'eyeL on
		readadc whiskerR,temp0
'		high whiskerLedR_			'eyeL off
		sertxd("R",#temp0)
		temp0 =temp0 /8
		tempLo_wRg =tempLo_wRg +temp0
		sertxd(" ",#tempLo_wRg,cr)
	  next i	
	high whiskerLedR_				'eyeL off
'set threshold at 60%
	tempHi_wLg =tempHi_wLg *3 /5
	tempLo_wRg =tempLo_wRg *3 /5
  sertxd("holethresh L",#tempHi_wLg," R",#tempLo_wRg,cr)
	write EEholedetectL,tempHi_wLg
	write EEholedetectR,tempLo_wRg
	return 

QGwhiskerL:
	low whiskerLedL_			'LwLED on
	readadc whiskerL,tempHi_wLg
	high whiskerLedL_			'LwLED off
	readadc whiskerL,lightL
	if lightL>tempHi_wLg then	'why this happens I don't know
		 lightL =tempHi_wLg	
	  endif	
	read EEholedetectL,temp0
	if tempHi_wLg<temp0 then 		'a hole, no ground detected
		obstacle =obstacle or %10 
	  endif
sertxd(cr,"wL",#tempHi_wLg)  
	return 

QGwhiskerR:
	low whiskerLedR_			'RwLED on
	readadc whiskerR,tempLo_wRg
	high  whiskerLedR_		'RwLED off
	readadc whiskerR,lightR		'ambient light
	if lightR>tempLo_wRg then	'why this happens I don't know
		 lightL =tempLo_wRg	
	  endif	
	read EEholedetectR,temp0
	if tempLo_wRg<temp0 then 		'a hole, no ground detected
		obstacle =obstacle or %01 
	  endif
  sertxd(" wR",#tempLo_wRg)
	return 
'-----------------------------------------

